<template>
    <div>
        <br>
        <div>
            <h5>Neue Unterrichtseinheit hinzufügen</h5>
            <b-button id="show-btn" variant="success" @click="showModal">
                <b-icon icon="plus-square" aria-hidden="true"></b-icon>
            </b-button>

            <b-modal ref="my-modal" @hidden="resetModal" hide-footer>
                <div class="d-block text-center">
                    <form method="post">
                        <b-container fluid>

                            <b-row class="my-1">
                                <b-col sm="1">
                                </b-col>
                                <b-col sm="10">
                                    <label for="tags-basic">Fach wählen</label>
                                    <select class="form-select form-select-lg mb-3" aria-label=".form-select-lg example"
                                        v-model="fach.fachEnums">
                                        <option value="JAVA">Java</option>
                                        <option value="WEB">Web</option>
                                        <option value="DATENBANKEN">Datenbanken</option>
                                        <option value="WINDOWS">Windows</option>
                                        <option value="LINUX">Linux</option>
                                        <option value="KARRIERECOACHING">Karrierecoaching</option>
                                    </select>
                                </b-col>
                            </b-row>

                            <b-row class="my-1">
                                <b-col sm="1">
                                </b-col>
                                <b-col sm="10">
                                    <b-form-input id="input-large" size="lg" placeholder="Bezeichnung eingeben"
                                        v-model="fach.description"></b-form-input>
                                </b-col>
                            </b-row>

                            
                        </b-container>
                        <div>
                            <b-button block variant="outline-success" @click="postFach()">
                                Speichern</b-button>
                        </div>
                    </form>
                </div>
            </b-modal>

        </div>

        <div>
            <b-modal ref="my-modal1" hide-footer>
                <div class="d-block text-center">
                    <form method="post">
                        <b-container fluid>

                            <b-row class="my-1">
                                <b-col sm="1">
                                </b-col>
                                <b-col sm="10">
                                    <label for="tags-basic">Fach wählen</label>
                                    <select class="form-select form-select-lg mb-3" aria-label=".form-select-lg example"
                                        v-model="editFaecher.fachEnums">
                                        <option value="JAVA">Java</option>
                                        <option value="WEB">Web</option>
                                        <option value="DATENBANKEN">Datenbanken</option>
                                        <option value="WINDOWS">Windows</option>
                                        <option value="LINUX">Linux</option>
                                        <option value="KARRIERECOACHING">Karrierecoaching</option>
                                    </select>
                                </b-col>
                            </b-row>

                            <b-row class="my-1">
                                <b-col sm="1">
                                </b-col>
                                <b-col sm="10">
                                    <b-form-input id="input-large" size="lg" placeholder="Bezeichnung eingeben"
                                        v-model="editFaecher.description"></b-form-input>
                                </b-col>
                            </b-row>

                        </b-container>
                        <div>
                            <b-button block variant="outline-success" @click="putFach()">
                                Speichern</b-button>
                        </div>
                    </form>
                </div>
            </b-modal>
        </div>

        <br>

        <table class="table">
            <tbody>
                <tr>
                    <!-- <th>ID</th> -->
                    <th>Fach</th>
                    <th>Thema</th>
                    <th></th>
                    <th></th>
                </tr>
                <tr v-for="fach in faecher" v-bind:key="fach.id">
                    <!-- <td>{{ fach.fach_id }}</td> -->
                    <td>{{ fach.fachEnums }}</td>
                    <td>{{ fach.description }}</td>
                    <td>
                        <b-button id="show-btn" @click="showModal1(fach.fach_id), editFach(fach)" variant="primary">
                            <b-icon icon="pencil" aria-hidden="true"></b-icon>
                        </b-button>
                    </td>
                    <td>
                        <b-button @click="deleteFach(fach.fach_id)" variant="danger">
                            <b-icon icon="trash-fill" aria-hidden="true"></b-icon>
                        </b-button>
                    </td>
                </tr>
            </tbody>

        </table>
    </div>
</template>

<script>

export default {
    name: "FachListe",
    data() {
        return {
            modalShow: false,
            fach: {
                description: '',
                fachEnums: ''
            },
            editFaecher: {
                description: '',
                fachEnums: '',
                fach_id: ''
            }
        }
    },
    computed: {
        faecher() {
            return this.$store.state.faecher;
        }
    },
    methods:
    {
        deleteFach(fach_id) {
            this.$store.dispatch('deleteFach', fach_id)
        },

        postFach() {
            this.$store.dispatch('postFach', this.fach)
            this.hideModal()
        },

        putFach() {
            this.$store.dispatch('putFach', this.editFaecher)
            this.hideModal1()
        },

        async editFach(fach) {
            this.editFaecher.description = fach.description;
            this.editFaecher.fachEnums = fach.fachEnums;
            this.editFaecher.fach_id = fach.fach_id;
        },

        resetModal() {
            this.fach.description = '';
            this.fach.fachEnums = '';
        },

        showModal() {
            this.$refs['my-modal'].show()
        },
        showModal1() {
            this.$refs['my-modal1'].show()
        },
        hideModal() {
            this.$refs['my-modal'].hide()
        },
        hideModal1() {
            this.$refs['my-modal1'].hide()
        }
    },
    mounted() {
        this.$store.dispatch('getAlleFaecher')
    }
}
</script>